xine-lib: xine-lib-1.2.12/src/post/visualizations/oscope.c File Reference

xine-lib 1.2.12

Data Structures | Macros | Typedefs | Functions
oscope.c File Reference
`#include <stdio.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/post.h>`
`#include "visualizations.h"`

## Data Structures
struct | post_plugin_oscope_s

## Macros
#define | FPS 20
#define | NUMSAMPLES 512
#define | MAXCHANNELS 6
#define | OSCOPE_WIDTH NUMSAMPLES
#define | OSCOPE_HEIGHT 256

## Typedefs
typedef struct post_plugin_oscope_s | post_plugin_oscope_t

## Functions
static void | draw_oscope_dots (post_plugin_oscope_t *this)
static int | oscope_rewire_video (xine_post_out_t *output_gen, void *data)
static int | oscope_port_open (xine_audio_port_t *port_gen, xine_stream_t *stream, uint32_t bits, uint32_t rate, int mode)
static void | oscope_port_close (xine_audio_port_t *port_gen, xine_stream_t *stream)
static void | oscope_port_put_buffer (xine_audio_port_t *port_gen, audio_buffer_t *buf, xine_stream_t *stream)
static void | oscope_dispose (post_plugin_t *this_gen)
static post_plugin_t * | oscope_open_plugin (post_class_t *class_gen, int inputs, xine_audio_port_t **audio_target, xine_video_port_t **video_target)
void * | oscope_init_plugin (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ FPS

#define FPS 20

## ◆ MAXCHANNELS

#define MAXCHANNELS 6

## ◆ NUMSAMPLES

#define NUMSAMPLES 512

## ◆ OSCOPE_HEIGHT

#define OSCOPE_HEIGHT 256

## ◆ OSCOPE_WIDTH

#define OSCOPE_WIDTH NUMSAMPLES

## Typedef Documentation

## ◆ post_plugin_oscope_t

typedef struct post_plugin_oscope_s post_plugin_oscope_t

## Function Documentation

## ◆ draw_oscope_dots()

static void draw_oscope_dots | ( | post_plugin_oscope_t * | this | ) |
| static

References NUMSAMPLES, OSCOPE_HEIGHT, and OSCOPE_WIDTH.

Referenced by oscope_port_put_buffer().

## ◆ oscope_dispose()

static void oscope_dispose | ( | post_plugin_t * | this_gen | ) |
| static

References _x_freep(), and _x_post_dispose().

Referenced by oscope_open_plugin().

## ◆ oscope_init_plugin()

void * oscope_init_plugin | ( | xine_t * | xine,
|  | const void * | data
| ) |  |

References N_, NULL, post_class_s::open_plugin, and oscope_open_plugin().

## ◆ oscope_open_plugin()

static post_plugin_t * oscope_open_plugin | ( | post_class_t * | class_gen,
|  | int | inputs,
|  | xine_audio_port_t ** | audio_target,
|  | xine_video_port_t ** | video_target
| ) |  |
| static

References _x_post_init(), _x_post_intercept_audio_port(), xine_audio_port_s::close, xine_post_out_s::data, input(), xine_post_out_s::name, post_audio_port_s::new_port, NULL, xine_audio_port_s::open, oscope_dispose(), oscope_port_close(), oscope_port_open(), oscope_port_put_buffer(), oscope_rewire_video(), post_out_s::post, xine_audio_port_s::put_buffer, xine_post_out_s::rewire, xine_post_out_s::type, xine_list_push_back(), post_out_s::xine_out, and XINE_POST_DATA_VIDEO.

Referenced by oscope_init_plugin().

## ◆ oscope_port_close()

static void oscope_port_close | ( | xine_audio_port_t * | port_gen,
|  | xine_stream_t * | stream
| ) |  |
| static

References _x_post_dec_usage, xine_audio_port_s::close, NULL, post_audio_port_s::original_port, post_audio_port_s::post, post_audio_port_s::stream, and XINE_ANON_STREAM.

Referenced by oscope_open_plugin().

## ◆ oscope_port_open()

static int oscope_port_open | ( | xine_audio_port_t * | port_gen,
|  | xine_stream_t * | stream,
|  | uint32_t | bits,
|  | uint32_t | rate,
|  | int | mode
| ) |  |
| static

References _x_ao_mode2channels(), _x_metronom_init(), _x_post_inc_usage, _x_post_rewire(), post_audio_port_s::bits, bits, FPS, init_yuv_planes(), MAXCHANNELS, xine_stream_s::metronom, post_audio_port_s::mode, mode(), xine_audio_port_s::open, post_audio_port_s::original_port, OSCOPE_HEIGHT, OSCOPE_WIDTH, post_audio_port_s::post, post_audio_port_s::rate, post_audio_port_s::stream, xine_stream_s::xine, and XINE_ANON_STREAM.

Referenced by oscope_open_plugin().

## ◆ oscope_port_put_buffer()

static void oscope_port_put_buffer | ( | xine_audio_port_t * | port_gen,
|  | audio_buffer_t * | buf,
|  | xine_stream_t * | stream
| ) |  |
| static

References post_audio_port_s::bits, draw_oscope_dots(), audio_buffer_s::mem, audio_buffer_s::mem_size, audio_buffer_s::num_frames, NUMSAMPLES, post_audio_port_s::original_port, OSCOPE_HEIGHT, OSCOPE_WIDTH, post_audio_port_s::post, xine_audio_port_s::put_buffer, post_audio_port_s::rate, VO_BOTH_FIELDS, audio_buffer_s::vpts, XINE_ANON_STREAM, XINE_IMGFMT_YUY2, and yuv444_to_yuy2.

Referenced by oscope_open_plugin().

## ◆ oscope_rewire_video()

static int oscope_rewire_video | ( | xine_post_out_t * | output_gen,
|  | void * | data
| ) |  |
| static

References xine_video_port_s::close, xine_post_out_s::data, post_out_s::post, and XINE_ANON_STREAM.

Referenced by oscope_open_plugin().